设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 49|回复: 1

[工具] 【工具】批量对象原地缩放(以自身的几何中心)

[复制链接]

已领礼包: 20个

财富等级: 恭喜发财

发表于 7 天前 | 显示全部楼层 |阅读模式
  • 插件名称 : 原地缩放
  • 作  者 : marting
  • 运行环境 :XDRX API 晓东工具箱 
  • 发布时间 :2020-06-27
  • 命令名称 :xdtb_sclori
  • 插件介绍 :批量对象原地缩放(自身几何中心)
  • 备  注 : (点击图片可以放大)
(点击图片可以放大)

晓东温馨提示 1、运行环境为 晓东工具箱XDRX API 的插件,请下载最新版本的 晓东工具箱XDRX API开发环境 一键安装
2、在ACAD中如何加载插件,请看 论坛插件使用方法
3、如果您有要求需要定制插件,请到 编程申请 论坛发帖求助

插件详细内容

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 newer 于 2020-6-27 08:51 编辑

  1. (defun c:xdtb_sclori (/ ss p1 p2 x t1 t2 mat scl)
  2.   (if (setq ss
  3.              (xdrx-ssget
  4.                "\n*** 图元原地缩放((物体中心为基点)) ***\n选择要缩放的对象<退出>:"
  5.              )
  6.       )
  7.     (progn
  8.       (xdrx-begin)
  9.       (setvar "lastpoint" '(0 0 0))
  10.       (xdrx-sysvar-push '("osmode" 33))
  11.       (if (and (xdrx-initget 1 "R")
  12.                (setq p0 (getvar "lastpoint"))
  13.                (setq
  14.                  p1 (getreal (xdrx-prompt "\n请输入比例因子或[参照(R)]" t))
  15.                )
  16.           )
  17.         (progn
  18.           (cond
  19.             ((= p1 "R")
  20.              (setq pp (getvar "lastpoint"))
  21.              (if (not (setq t1 (getpoint "\n指定参照长度: <1>")))
  22.                (setq dist1 1.0)
  23.                (progn
  24.                  (if (= (xdrx-getvar "lastinput") 0)
  25.                    (setq dist1 (distance t1 pp))
  26.                    (progn (initget 1)
  27.                           (if (setq t2 (getpoint t1 "\n指定第二点:"))
  28.                             (setq dist1 (distance t2 t1))
  29.                           )
  30.                    )
  31.                  )
  32.                )
  33.              )
  34.              (if
  35.                (and
  36.                  dist1
  37.                  (setq d1 (getpoint "\n指定新长度:"))
  38.                  (progn
  39.                    (if (= (xdrx-getvar "lastinput") 0)
  40.                      (setq dist2 (distance d1 pp))
  41.                      (progn (initget 1)
  42.                             (if        (setq d2 (getpoint d1 "\n指定第二点:"))
  43.                               (setq dist2 (distance d2 d1))
  44.                             )
  45.                      )
  46.                    )
  47.                  )
  48.                )
  49.                 (setq scl (/ dist2 dist1))
  50.              )
  51.             )
  52.             ((= (type p1) 'real) (setq scl p1))
  53.           )
  54.         )
  55.         (setq v (getvar "ucsydir"))
  56.       )
  57.       (if scl
  58.         (progn (mapcar '(lambda        (x)
  59.                           (setq        mat (xdrx-matrix-setscale
  60.                                       scl
  61.                                       (trans (xd::geom:get9pt x 5) 1 0)
  62.                                     )
  63.                           )
  64.                           (xdrx-entity-transform x mat)
  65.                         )
  66.                        (xdrx-pickset->ents ss)
  67.                )
  68.                (xdrx-prompt "\n共原位缩放了 " (sslength ss) " 个对象.")
  69.         )
  70.       )
  71.       (xdrx-sysvar-pop)
  72.       (xdrx-end)
  73.     )
  74.   )
  75.   (princ)
  76. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 4个

财富等级: 恭喜发财

发表于 7 天前 | 显示全部楼层
非常有用,多谢大佬分享
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-7-4 12:26 , Processed in 0.118181 second(s), 27 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表